function [Vxstart, xtraj, utraj, ts] = execute_greedy_policy_wrt_V(V, xstart, us, dt, H, discount, mode, xmin, xmax, d, delaunayparams);

dx = (xmax-xmin)/d;

xtraj = zeros(2,H);
xtraj(:,1) = xstart;
utraj = zeros(1,H);

Vxstart = 0; 

ts = (1:H)*dt;
U = length(us);

for t=1:H-1
	%% YOUR CODE HERE
    %% The policy should be greedy w.r.t. V.  This means that for each potential action, you should evaluate the
    %% cost at the current time for current state and that action; as well
    %% as simulate forward (using sim_brick.m) and then evaluate the value
    %% at the next-state.  Note this next-state will rarely if ever be one
    %% of the grid-points, so you will need to do interpolation ('nn' or 'delaunay') to get its
    %% value.
    %% 
    %% Yes, you will have to look at the code inside
    %% build_discretized_MDP_for_brick.m.
    %% 
	%% for delaunay, the following call might be helpful: 
	%%  [trirow, pnext] = tsearchn(delaunayparams.states', delaunayparams.tri, xnext')
	%%  delaunayparams.states: matrix containing all the states in the grid
        %%  delaunayparams.tri: matrix containing all the triangles of the delaunay triangulation

	%%  trirow: will contain the index of the triangle in the delaunay triangulation in which xnext lies
	%%  delaunayparams.tri(trirow,:)  will return a vector with the discrete indexes of the vertices of the triangle
	%%  pnext: contains the convex weights associated with each of the vertices of the triangle
	
	utraj(:,t) = us(:, 1); %% YOUR CODE above should fill in the action choice!
    
    
	Vxstart = Vxstart + discount^(t-1)*brick_cost(xtraj(:,t), utraj(:,t));
        xtraj(:,t+1) = sim_brick(xtraj(:,t), utraj(:,t), dt);
end

utraj(:,H) = utraj(:,H-1);
