function plot_V(xmin, xmax, d, figure_number, mode, V)

% in case of discretized mode:
% V contains the value function
% in case of LQR: V = Ps
dx = (xmax-xmin)/d;
skip=3; % to get similar scale by avoiding plotting close to boundary, where there are boundary effects
x1s =  xmin(1)+skip*dx(1):dx(1):xmax(1)-skip*dx(1);
x2s =  xmin(2)+skip*dx(2):dx(2):xmax(2)-skip*dx(2);
[X,Y] = meshgrid(x1s, x2s);


if(strcmp(mode,'lqr'))
    Ps = V;
    i=1;

    for x1 = x1s
        j=1;
        for x2 = x2s
            x = [x1; x2];
            Vs_lqr(i,j) = x'*Ps*x;
            j=j+1;
        end
        i=i+1;
    end
    figure(figure_number); contour(X, Y, Vs_lqr); colorbar; axis([ xmin(1) xmax(1)  xmin(2) xmax(2)]); 
    title(['V, mode = ' mode ' d = ' num2str(d)]);
    figure(50+figure_number); imagesc([x1s(1);x1s(end)], [x2s(1);x2s(end)], Vs_lqr); colorbar; axis([ xmin(1) xmax(1)  xmin(2) xmax(2)]);
    title(['V, mode = ' mode ' d = ' num2str(d)]);
else % discretized mode
    i=1;
    for x1 = x1s
        j=1;
        for x2 = x2s
            x = [x1; x2];

            curr_idx = continuous_to_discrete(x, xmin, xmax, dx);
            Vs(i,j) = V(curr_idx);
            j=j+1;
        end
        i=i+1;
    end
    figure(figure_number); contour(X, Y, Vs); colorbar; axis([ xmin(1) xmax(1)  xmin(2) xmax(2)]); 
    title(['V, mode = ' mode ' d = ' num2str(d)]);
    figure(50+figure_number); imagesc([x1s(1);x1s(end)], [x2s(1);x2s(end)], Vs); colorbar; axis([ xmin(1) xmax(1)  xmin(2) xmax(2)]);
    title(['V, mode = ' mode ' d = ' num2str(d)]);
end


