%Author: Woody Hoburg
%Modified by: Pieter Abbeel
function [J,dJda,tout,xout] = rtrl(PLANTFUN,CONTROLFUN,COSTFUN,FINALCOSTFUN,T,X0,alpha)

nX = length(X0);
nA = length(alpha);
u0 = CONTROLFUN(0,X0,alpha,T);
nU = length(u0);

% Euler version [could use ode45 or other matlab solver instead, but more data
% munging and juggling with function arguments required]

x = X0; P = zeros(nX,nA); J = 0; dJda = zeros(1,nA);
dt = 0.01;
tout = 0:dt:(T-dt);
k=1;
for t=0:dt:(T-dt)
    xout(k,:) = x;
    %% YOUR CODE will implement rtrl_dyn
    [xdot,Pdot,Jdot,dJdadot] = rtrl_dyn(t,x,P,PLANTFUN,CONTROLFUN,COSTFUN,T,alpha);
    x = x + dt*xdot;
    P = P + dt*Pdot;
    J = J + dt*Jdot;
    dJda = dJda + dt*dJdadot;
    k=k+1;
end

%% YOUR CODE HERE -- add in the final cost appropriately



return;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    function [xdot,Pdot,Jdot,dJdadot] = rtrl_dyn(t,x,P,PLANTFUN,CONTROLFUN,COSTFUN,T,alpha)

        %% YOUR CODE HERE
        %% dumb place holders:
        xdot = zeros(size(x));
        Pdot = zeros(size(P));
        Jdot = 0;
        dJdadot = zeros(size(alpha));

